using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace UVAnimationTest2
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;


        // f̐錾
        private const int modelMax = 1000;

        // ̐錾
        public static Random random = new Random();


        // f̐錾
        private Model[] myModel = new Model[modelMax];

        // eNX`̐錾
        private Texture2D myTexture;

        // JX^GtFNg̐錾
        private Effect myEffect;

        // fW̐錾
        private Vector3[] modelPos = new Vector3[modelMax];

        // ^C}[̐錾
        private float[] timer = new float[modelMax];



        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here

            // eNX`̌Ăяo
            myTexture = Content.Load<Texture2D>("SpearMan01Attack01");

            // JX^GtFNǧĂяo
            myEffect = Content.Load<Effect>("MyBasicEffect");

            // r[Wϊs
            Matrix view = Matrix.CreateLookAt(
                new Vector3(0, 0, 400),
                Vector3.Zero,
                Vector3.Up);

            // ˉeϊs
            Viewport viewport = graphics.GraphicsDevice.Viewport;
            float aspectRatio = (float)viewport.Width / (float)viewport.Height;
            Matrix projection = Matrix.CreatePerspectiveFieldOfView(
                MathHelper.PiOver4,
                aspectRatio,
                10, 1000);

            // r[Aˉeϊs̐ݒ
            myEffect.Parameters["View"].SetValue(view);
            myEffect.Parameters["Projection"].SetValue(projection);

            // `惂[huTexturedvɐݒiBasicEffect ShaderthLgQƁj
            myEffect.Parameters["ShaderIndex"].SetValue(2);
            myEffect.Parameters["BasicTexture"].SetValue(myTexture);

            for (int i = 0; i < modelMax; i++)
            {
                // fW_ɐݒ
                modelPos[i].X = (float)random.Next(300) - 150;
                modelPos[i].Y = (float)random.Next(300) - 150;
                modelPos[i].Z = (float)random.Next(300) - 150;

                // ^C}[̏l_ɐݒ
                timer[i] = (float)random.Next(10000);

                // f̌Ăяo
                myModel[i] = Content.Load<Model>("MyModel02");
                foreach (ModelMesh mesh in myModel[i].Meshes)
                {
                    foreach (ModelMeshPart modelMeshPart in mesh.MeshParts)
                    {
                        // JX^GtFNgɍւ
                        modelMeshPart.Effect = myEffect;
                    }
                }
            }
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here

            for (int i = 0; i < modelMax; i++)
            {
                // ^C}[̍XV
                timer[i] += (float)gameTime.ElapsedGameTime.TotalMilliseconds;

                // \AjԍZo
                int animeNo = (int)(timer[i] / 80);
                if (animeNo >= 32 * 19)
                {
                    animeNo = 0;
                    timer[i] = 0;
                }

                // eNX`WZo
                int iWidth = 80;    // 摜P̉iintj
                int iHeight = 80;   // 摜P̏ciintj
                int animeWidthMax = 25;    // Aj摜̉
                float fWidth = (float)iWidth / (float)myTexture.Width;    // 摜P̉ifloatj
                float fHeight = (float)iHeight / (float)myTexture.Height; // 摜P̏cifloatj
                float tx1 = (animeNo % animeWidthMax) * fWidth;
                float ty1 = (animeNo / animeWidthMax) * fHeight;
                float tx2 = tx1 + fWidth;
                float ty2 = ty1 + fHeight;

                // AjeNX`W̐ݒ
                Vector2 TexCoord1 = new Vector2(tx1, ty1);
                myEffect.Parameters["TexCoord1"].SetValue(TexCoord1);


                // [hWϊs
                Matrix world = Matrix.CreateScale(20.0f) *
                    Matrix.CreateRotationX(timer[i] / 3000f) *
                    Matrix.CreateRotationY(timer[i] / 1000) *
                    Matrix.CreateTranslation(modelPos[i]);

                // [hWϊs̐ݒ
                myEffect.Parameters["World"].SetValue(world);


                foreach (ModelMesh mesh in myModel[i].Meshes)
                {
                    // f\
                    mesh.Draw();
                }
            }

            base.Draw(gameTime);
        }
    }
}
